(********************************************************)
(*                       ATNBOX.INC                     *)
(*   Include-Datei mit den Prozeduren fr eine          *)
(*   natrlichsprachliche Schnittstelle von "KARTEI"    *)
(*   2.) Erweiterungen zur Handhabung von Anaphorismen  *)
(*           (C) 1989 Stephan Diehl & TOOLBOX           *)


FUNCTION match : BOOLEAN;
(* Sucht die nchste Karteikarte, die zu den *)
(* aktuellen Suchbegriffen pat              *)

VAR bb:BOOLEAN;

BEGIN
  bb:=FALSE;
  IF karte<>NIL THEN
  WHILE (((suchbegriff[inh4]^.begriff
           <>karte^.inhalt[ 4])
          AND (suchbegriff[inh4]^.begriff
               <>wildcard))
      OR ((suchbegriff[inh3]^.begriff
           <>karte^.inhalt[3])
          AND (suchbegriff[inh3]^.begriff
               <>wildcard))
      OR ((suchbegriff[inh2]^.begriff
           <>karte^.inhalt[2])
          AND (suchbegriff[inh2]^.begriff
               <>wildcard))
      OR ((suchbegriff[inh1]^.begriff
           <>karte^.inhalt[1])
          AND (suchbegriff[inh1]^.begriff
               <>wildcard)) )
          AND NOT bb
    DO BEGIN
      IF karte<>NIL THEN
        karte:=karte^.naechste
      ELSE
        bb:=TRUE;
    END
    ELSE bb:=TRUE;
  match:=NOT bb;
END;



PROCEDURE aktionen_ausfuehren;
BEGIN
  befehl:=erster_befehl;
  IF befehl=NIL THEN feld_mit_inhalt_ausgeben(z)
  ELSE
    REPEAT
      CASE befehl^.anw OF
        monitor  : feld_mit_inhalt_ausgeben(z);
        drucker  : BEGIN
                     feld_mit_inhalt_ausdrucken(z);
                     auf_drucker:=TRUE;
                   END;
        loeschen : BEGIN
                     Write('Sind Sie sicher,da diese ');
                     Write('Karte gelscht ');
                     WriteLn('werden soll:');
                     FOR u:=1 TO 4 DO
                       feld_mit_inhalt_ausgeben(u);
                     WriteLn;WriteLn('j/n');
                     IF ant='j' THEN BEGIN
                       IF karte=erste_karte THEN
                         erste_karte:=karte^.naechste
                       ELSE BEGIN
                         ksuch2:=NIL;
                         ksuch1:=erste_karte;
                         WHILE ksuch1<>karte DO BEGIN
                           ksuch2:=ksuch1;
                           ksuch1:=ksuch1^.naechste;
                         END;
                         ksuch2^.naechste
                           :=karte^.naechste;
                       END;
                       Dispose(karte); kartanz:=kartanz-1;
                       cty:=inh4;
                       (* => kein weiteres feld *)
                       WriteLn('Karte gelscht !!!');
                     END;
                   END;
       editieren : BEGIN
                     IF no_feld
                        OR  (no_feld2 AND zweite_anfrage)
                        THEN BEGIN
                       editiere_karteikarte(karte);
                       cty:=inh4;
                      END
                      ELSE BEGIN
                        feld_mit_inhalt_ausgeben(z);
                        WriteLn;
                        WriteLn(
                          'Wollen Sie dies ndern ?');
                        WriteLn('j/n'); ReadLn(ant);
                        WriteLn;
                        IF ant='j' THEN BEGIN
                          Write(feldnamen[karte^.
                                          kartentyp,z],
                                          ': ');
                          ReadLn(karte^.inhalt[z]);
                        END;
                      END;
                    END;
     kartedrucken : BEGIN
                      FOR u:=1 TO 4 DO BEGIN
                        feld_mit_inhalt_ausdrucken(u);
                        WriteLn(LST);
                      END;
                      WriteLn(LST);WriteLn(LST);
                      WriteLn(LST,feldnamen[karte^.
                                            kartentyp,
                                            5],': ');
                      WriteLn(LST);
                      FOR u:=1 TO 7 DO
                        WriteLn(LST,karte^.inhalt5[u]);
                      WriteLn(LST); WriteLn(LST);
                      WriteLn(LST); WriteLn(LST);
                      WriteLn(LST);
                      cty:=inh4;
               (* => kein weiteres feld bearbeiten *)
                    END;
      END;
      befehl:=befehl^.naechste;
    UNTIL befehl=NIL;
END;


PROCEDURE feldinhalt_ausgeben;
(* Die Aktionen werden mit allen Feldinhalten *)
(* durchgefhrt, nach denen gefragt wurde     *)
BEGIN
  suchbegriff[feld]:=erster_begriff[feld];
  REPEAT
    cty:=inh1;
    REPEAT
      z:=Ord(cty);
      IF (suchbegriff[feld]^.begriff=wildcard)
         OR (feldnamen[karte^.kartentyp,z]
             =suchbegriff[feld]^.begriff) THEN
        aktionen_ausfuehren;
      cty:=Succ(cty);
    UNTIL cty=inh5;
    suchbegriff[feld]:=suchbegriff[feld]^.naechste;
  UNTIL suchbegriff[feld]=NIL;
END;


PROCEDURE drucke_antwort;
(* Die Karteikarten werden nach allen  *)
(* Kombinationen von Suchbegriffen der *)
(* verschiedenen Felder durchsucht     *)

VAR xyi:INTEGER;

BEGIN
  schwarzaufweiss;
  FOR xyi:=3 TO 5 DO BEGIN
    resetfenster;
    fenster(xyi,xyi,81-xyi,26-xyi);
    ClrScr;
  END;
  weissaufschwarz;
  ClrScr;
  suchbegriff[inh1]:=erster_begriff[inh1];
  WHILE suchbegriff[inh1]<>NIL DO BEGIN
    suchbegriff[inh2]:=erster_begriff[inh2];
    WHILE suchbegriff[inh2]<>NIL DO BEGIN
      suchbegriff[inh3]:=erster_begriff[inh3];
      WHILE suchbegriff[inh3]<>NIL DO BEGIN
        suchbegriff[inh4]:=erster_begriff[inh4];
        WHILE suchbegriff[inh4]<>NIL DO BEGIN
          karte:=erste_karte;
          WHILE match AND (karte<>NIL) DO BEGIN
            auf_drucker:=FALSE;
            feldinhalt_ausgeben;
            IF auf_drucker THEN WriteLn(LST)
            ELSE WriteLn;
            IF karte<>NIL THEN karte:=karte^.naechste;
          END;
          suchbegriff[inh4]
            :=suchbegriff[inh4]^.naechste;
        END;
        suchbegriff[inh3]:=suchbegriff[inh3]^.naechste;
      END;
      suchbegriff[inh2]:=suchbegriff[inh2]^.naechste;
    END;
    suchbegriff[inh1]:=suchbegriff[inh1]^.naechste;
  END;
  weissaufschwarz;
  resetfenster;
END;


(*-------------------------------------------------------*)
(* Prozeduren zum Zugriff auf die vorherige Antwort      *)
PROCEDURE merke_letzte_antwort;

VAR ct:kategorien;
    temp : wlistzeiger;

BEGIN
  FOR ct:=feld TO inh5 DO BEGIN
    suchbegriff[ct]:=letzte_antwort_suchbegriffe[ct];
    WHILE suchbegriff[ct]<>NIL DO BEGIN
      letzter_begriff[ct]:=suchbegriff[ct];
      suchbegriff[ct]:=suchbegriff[ct]^.naechste;
      Dispose(letzter_begriff[ct]);
    END;
  END;
  FOR ct:=feld TO inh5 DO BEGIN
    letzte_antwort_suchbegriffe[ct]:=erster_begriff[ct];
    letzter_begriff[ct]:=NIL;
    erster_begriff[ct]:=NIL;
  END;
  befehl:=letzte_antwort_befehle;
  (* Lsche die Befehlsliste *)
  WHILE befehl<>NIL DO BEGIN
    letzter_befehl:=befehl;
    befehl:=befehl^.naechste;
    Dispose(letzter_befehl);
  END;
  letzte_antwort_befehle:=erster_befehl;
  erster_befehl:=NIL;
  merke_sortierer:=sortierer;
  merke_nach:=nach;
  merke_no_feld2:=no_feld2;
  merke_no_feld:=no_feld;
END;

PROCEDURE nimm_letzte_befehle;

VAR bfhl:befehlszeiger;

BEGIN
  sortierer:=merke_sortierer;
  no_feld:=merke_no_feld;
  no_feld2:=merke_no_feld2;
  bfhl:=erster_befehl;
  (* Lsche die Befehlsliste *)
  WHILE bfhl<>NIL DO BEGIN
    letzter_befehl:=bfhl;
    bfhl:=bfhl^.naechste;
    Dispose(letzter_befehl);
  END;
  bfhl:=letzte_antwort_befehle;
  erster_befehl:=NIL;
  WHILE bfhl<>NIL DO BEGIN
    New(befehl);
    IF erster_befehl=NIL THEN
      erster_befehl:=befehl
    ELSE
      letzter_befehl^.naechste:=befehl;
    befehl^.anw:=bfhl^.anw;
    befehl^.naechste:=NIL;
    letzter_befehl:=befehl;
    bfhl:=bfhl^.naechste;
  END;
END;

PROCEDURE kopiere(ct:kategorien);
BEGIN
  begriff[ct]:=erster_begriff[ct];
  WHILE begriff[ct]<>NIL DO BEGIN
    letzter_begriff[ct]:=begriff[ct];
    begriff[ct]:=begriff[ct]^.naechste;
  END;
  begriff[ct]:=letzte_antwort_suchbegriffe[ct];
  WHILE begriff[ct]<>NIL DO BEGIN
    New(suchbegriff[ct]);
    IF erster_begriff[ct]=NIL THEN
      erster_begriff[ct]:=suchbegriff[ct]
    ELSE
      letzter_begriff[ct]^.naechste:=suchbegriff[ct];
    suchbegriff[ct]^.naechste:=NIL;
    suchbegriff[ct]^.begriff:=begriff[ct]^.begriff;
    letzter_begriff[ct]:=suchbegriff[ct];
    begriff[ct]:=begriff[ct]^.naechste;
  END;
END;


PROCEDURE nimm_letzte_suchbegriffe;

VAR  ct: kategorien;

BEGIN
  IF NOT merke_no_feld THEN no_feld:=FALSE;
  no_feld2:=FALSE;
  FOR ct:=feld TO inh5 DO  kopiere(ct);
END;


PROCEDURE nimm_letzte_suchinhalte;

VAR ct:kategorien;

BEGIN
  FOR ct:=inh1 TO inh5 DO kopiere(ct);
END;


PROCEDURE nimm_letzte_suchfelder;
BEGIN
  IF NOT merke_no_feld THEN no_feld:=FALSE;
  no_feld2:=FALSE;
  kopiere(feld);
END;


PROCEDURE getcategory;
(* Liefert die Kategorie des      *)
(* nchsten Wortes in der Eingabe *)

VAR bb, is_bdl:BOOLEAN;

BEGIN
  REPEAT
    IF eingabe='' THEN category:=pop
    ELSE BEGIN
      u:=Length(eingabe);
      z:=1;
      IF eingabe[1]='"' THEN BEGIN
        wort:=Copy(eingabe,2,
                   Pos('"',Copy(eingabe,2,u-1))-1);
        z:=Length(wort)+4;
      END
      ELSE BEGIN
        wort:=Copy(eingabe,1,Pos(' ',eingabe)-1);
        z:=Length(wort)+2;
      END;
      eingabe:=Copy(eingabe,z,u-z+1);
      kt:=nix;
      is_bdl:=FALSE;
      anweis:=keine;
      category:=bdl;
      IF (wort='nach') OR (wort='NACH') THEN nach:=TRUE
      ELSE IF (wort='und') OR (wort='UND') THEN und:=TRUE
           ELSE BEGIN (* Ist das Wort eine Anweisung ? *)
             FOR z:=1 TO bdlanz DO
               IF wort=bdlos[z] THEN is_bdl:=TRUE;
             FOR z:=1 TO PRaePANZ DO
               IF wort=PRaeP[z] THEN
                 category:=PRaePOSITION;
             FOR z:=1 TO MARKANZ DO
               IF wort=Mark[z] THEN category:=MARKER;
             FOR z:=1 TO ARTANZ DO
               IF wort=ART[z] THEN category:=ARTIKEL;
             IF category IN [MARKER,ARTIKEL] THEN
               REFLEXIV:=TRUE;
             FOR z:=1 TO sortanz DO
               IF wort=sort[z] THEN anweis:=sortieren;
             IF anweis=keine THEN
               FOR z:=1 TO monanz DO
                 IF wort=mon[z] THEN anweis:=monitor;
             IF anweis=keine THEN
               FOR z:=1 TO druckanz DO
                 IF wort=druck[z] THEN anweis:=drucker;
             IF anweis=keine THEN
               FOR z:=1 TO editanz DO
                 IF wort=edit[z] THEN anweis:=editieren;
             IF anweis=keine THEN
               FOR z:=1 TO loeschanz DO
                 IF wort=loesch[z] THEN anweis:=loeschen;
             IF anweis=keine THEN
               FOR z:=1 TO kdruckanz DO
                 IF wort=kartdruck[z] THEN
                   anweis:=kartedrucken;
             IF (anweis<>keine) AND (category=bdl) THEN
               category:=anweisung
             ELSE IF category=bdl THEN BEGIN
               (* Ist das Wort ein Feldname ? *)
               bb:=FALSE;
               REPEAT
                 kt:=Succ(kt); z:=0;
                 REPEAT
                   z:=z+1;
                   hilfstr:=feldnamen[kt,z];
                   IF enthalten_in(wort,hilfstr) THEN
                     bb:=TRUE;
                 UNTIL bb OR (z=5);
               UNTIL (kt=letzter_typ) OR bb;
              IF bb THEN BEGIN
                category:=feld;
                no_feld2:=no_feld;
                no_feld:=FALSE;
              END
              ELSE BEGIN (* Ist das Wort ein Feldinhalt ?*)
                category:=bdl;
                hilf:=erste_karte;
                REPEAT
                  z:=0;
                  REPEAT
                    z:=z+1;
                    hilfstr:=hilf^.inhalt[z];
                    IF enthalten_in(wort,hilfstr) THEN
                      bb:=TRUE;
                  UNTIL bb OR (z=4);
                  IF bb THEN
                    CASE z OF
                      1: category:=inh1;
                      2: category:=inh2;
                      3: category:=inh3;
                      4: category:=inh4;
                    END;
                  hilf:=hilf^.naechste;
                  (* Bedeutungslose Wrter *)
                  (* werden berlesen      *)
                UNTIL (hilf=NIL) OR (category<>bdl);
              END;
            END;
      END;
    END;
  UNTIL category<>bdl;
END;


FUNCTION richtig_verstanden:BOOLEAN;

VAR begriffe:begriffsfeld;
    befehle:befehlszeiger;
    cty:kategorien;
    xi:INTEGER;
BEGIN
  schwarzaufweiss;
  resetfenster;
  IF hga THEN
    Move(speichere_bildschirm,bildschirm_hga,4000)
  ELSE
    Move(speichere_bildschirm,bildschirm_cga,4000);
  fenster(10,5,70,19);
  ClrScr;
  GotoXY(10,9);
  WriteLn(' Ich soll folgendes tun : ');
  begriffe:=erster_begriff;
  befehle:=erster_befehl;
  WriteLn;
  IF begriffe[feld]^.begriff<>wildcard THEN BEGIN
    IF begriffe[feld]^.naechste<>NIL THEN
      WriteLn(' folgende Felder:')
    ELSE
      WriteLn(' folgendes Feld:');
    WHILE begriffe[feld]<>NIL DO BEGIN
      Write('':10);
      weissaufschwarz;
      Write(begriffe[feld]^.begriff);
      schwarzaufweiss;
      WriteLn;
      begriffe[feld]:=begriffe[feld]^.naechste;
    END;
  END
  ELSE
    WriteLn(' alle Karteikarten ');
  WriteLn;
  IF (begriffe[inh1]^.begriff<>wildcard)
     OR (begriffe[inh2]^.begriff<>wildcard)
     OR (begriffe[inh3]^.begriff<>wildcard)
     OR (begriffe[inh4]^.begriff<>wildcard) THEN BEGIN
    WriteLn(' mit folgenden Feldinhalten:');
    FOR cty:=inh1 TO inh4 DO BEGIN
      WHILE begriffe[cty]<>NIL DO BEGIN
        Write('':10);
        weissaufschwarz;
        IF begriffe[cty]^.begriff<> wildcard THEN
          Write(begriffe[cty]^.begriff);
        schwarzaufweiss;
        WriteLn;
        begriffe[cty]:=begriffe[cty]^.naechste;
      END;
    END;
  END;
  Write(' soll ich ');
  IF befehle=NIL THEN
    WriteLn('auf dem Bildschirm ausgeben !');
  WHILE befehle<>NIL DO BEGIN
    IF befehle<>erster_befehl THEN
      Write(' und ');
    CASE befehle^.anw OF
            monitor  : WriteLn(
                       'auf dem Bildschirm ausgeben');
            drucker  : WriteLn(
                       'auf dem Drucker ausgeben');
            loeschen : WriteLn(
                       'aus der Kartei streichen');
           editieren : WriteLn('editieren');
        kartedrucken : WriteLn(
                       'formatiert auf dem ',
                       'Drucker ausgeben');
            sortieren : IF (sortierer<>wildcard)
                           AND (sortierer<>'') THEN
                          WriteLn('nach ',sortierer,
                                  ' sortieren')
                         ELSE
                           WriteLn('sortieren');
    END;
    befehle:=befehle^.naechste;
  END;
  resetfenster;
  resetfenster;TextColor(blink);
  fenster(19,22,62,23);
  TextColor(white);ClrScr;
  Write(' Ist diese Interpretation richtig ?  ');
  schwarzaufweiss;
  REPEAT
    Read(KBD,ant);
    IF ant=Chr(27) THEN hilfe(8);
  UNTIL ant IN ['j','J','n','N']; WriteLn; WriteLn;
  richtig_verstanden :=  (ant IN ['j','J']);
  weissaufschwarz;
  resetfenster;
  ClrScr;
END;




PROCEDURE anfragen;
VAR x,y:INTEGER;
BEGIN
  resetfenster;
  fenster(2,22,79,23);
  eingabe:=''; zeile:=1;
  ClrScr;WriteLn('Ihre Anfrage: ');
  x:=WhereX;y:=WhereY;
  weissaufschwarz;
  Write('':62);
  schwarzaufweiss;   GotoXY(x,y);
  my_readln(eingabe,76,3);
  merke_eingabe:=eingabe;
  IF eingabe<>'' THEN BEGIN
    eingabe:=eingabe+' ';
    antworten:=1;
    getcategory;
    (* Einfaches ATN mit einer Aktion, nmlich *)
    (* dem Erkennen einer zweiten Anfrage      *)
    REPEAT
      sortierer:=''; nach:=FALSE; no_feld:=TRUE;
      zustand:=za; (* Anfangszustand *)
     zweite_anfrage:=FALSE; no_feld2:=no_feld;
     REFLEXIV:=FALSE; und:=FALSE;
     LETZTES_WORT:=bdl;
     (* Initialisiere die Befehlsliste *)
     erster_befehl:=NIL; letzter_befehl:=NIL; befehl:=NIL;
     (* Initialisiere die Listen der Suchbegriffe *)
     FOR cty:=feld TO inh5 DO BEGIN
       suchbegriff[cty]:=NIL;
       erster_begriff[cty]:=NIL;
       letzter_begriff[cty]:=NIL;
     END;
     REPEAT
       (* Sonderbehandlung von UND *)
       IF und AND (category<>bdl)
          AND (category<>LETZTES_WORT) THEN
         zweite_anfrage:=TRUE
      ELSE BEGIN
        IF und AND (category=LETZTES_WORT) THEN und:=FALSE;
        LETZTES_WORT:=category;
        (* Kante von za,zc,zf,zd nach zb *)
        IF (zustand IN [za,zc,zf,zd])
            AND (category IN [inh1..inh4]) THEN zustand:=zb
        ELSE (* Kante von zb,zd oder ze nach za mit *)
             (* Aufruf  Aktion "Beantworte erste Anfrage" *)
          IF (zustand IN [zb,zd,ZE])
              AND (category=feld) THEN zweite_anfrage:=TRUE
        ELSE (* Kante von za nach zc *)
          IF (zustand=za)
             AND (category=PRaePOSITION) THEN zustand:=zc
        ELSE (* Kanten von zc nach za *)
          IF (zustand =zc) AND (category=feld) THEN
            zustand:=za
        ELSE (* Kanten von za nach zf *)
          IF (zustand=za)
             AND (category IN [ARTIKEL,MARKER]) THEN
            zustand:=zf
        ELSE (* Kante von zf nach ze *)
          IF (zustand=zf) AND (category=PRaePOSITION) THEN
           zustand:=ZE
        ELSE (* Kante von zf nach zb *)
          IF (zustand=zf)
             AND (category IN [inh1..inh4]) THEN
           zustand:=zb
        ELSE (* kanten von zf nach za *)
          IF (zustand=zf) AND
             (category IN [ARTIKEL,anweisung,feld,MARKER])
            THEN zustand:=za
        ELSE (* kanten von zb nach zd *)
          IF (zustand=zb)
             AND (category IN [MARKER,ARTIKEL]) THEN
            zustand:=zd
        ELSE (* kante von zd nach zb *)
          IF (zustand=zd)
             AND (category IN [inh1..inh4]) THEN
            zustand:=zb
        ELSE (* kante von zd nach ze *)
          IF (zustand=zd) AND (category=PRaePOSITION) THEN
            zustand:=ZE
        ELSE (* kante von ze nach zb *)
          IF (zustand =ZE)
             AND (category IN [inh1..inh4]) THEN BEGIN
            nimm_letzte_suchfelder;
            REFLEXIV:=FALSE;
            zustand:=zb;
          END
        ELSE
          IF (zustand=ZE) AND (category=MARKER) THEN BEGIN
            nimm_letzte_suchfelder;
            nimm_letzte_suchinhalte;
            zustand:=zb;
            REFLEXIV:=FALSE;
          END
        ELSE (* kanten von zc nach za *)
          IF (zustand = zc) AND (category=MARKER) THEN
          BEGIN
            nimm_letzte_suchinhalte;
            zustand:=za;
            REFLEXIV:=FALSE;
          END;

        (* Anweisung wird in die    *)
        (* Befehlsliste aufgenommen *)
        IF category=anweisung THEN BEGIN
          (* kante von zc nach za *)
          IF zustand=zc THEN zustand:=za;
          (* kanten von zd und ze nach zb *)
          IF zustand IN [zd,ZE] THEN zustand:=zb;
          New(befehl);
          IF erster_befehl=NIL THEN erster_befehl:=befehl
          ELSE letzter_befehl^.naechste:=befehl;
          befehl^.anw:=anweis;
          befehl^.naechste:=NIL;
          letzter_befehl:=befehl;
          getcategory;
        END
        ELSE BEGIN (* Sonderfall: Sortiere nach ... *)
          IF (category=feld) AND nach THEN BEGIN
            sortierer:=wort;
            nach:=FALSE;
            getcategory;
          END
          ELSE BEGIN
            (* Das Wort ist ein Feldname oder Feldinhalt *)
            (* und wird in die entsprechende Liste der   *)
            (* Suchbegriffe aufgenommen                  *)
            IF category IN [MARKER,ARTIKEL,PRaePOSITION]
            THEN getcategory
            ELSE IF  (category <> pop)
                     AND NOT zweite_anfrage THEN BEGIN
              New(suchbegriff[category]);
              IF erster_begriff[category]=NIL THEN
                erster_begriff[category]
                  :=suchbegriff[category]
              ELSE
                letzter_begriff[category]^.naechste
                  :=suchbegriff[category];
                suchbegriff[category]^.naechste:=NIL;
                suchbegriff[category]^.begriff:=wort;
                letzter_begriff[category]
                  :=suchbegriff[category];
                getcategory;
              END;
            END;
          END;
        END;
      UNTIL (category=pop) OR zweite_anfrage;
      (* Steht in einer der Listen kein Suchbegriff, *)
      (* dann sei der Suchbegriff die Wildcard       *)
      KEIN_SUCHBEGRIFF:=TRUE;
      FOR cty:=feld TO inh4 DO
        IF erster_begriff[cty]<>NIL THEN
          KEIN_SUCHBEGRIFF:=FALSE;
      IF REFLEXIV AND KEIN_SUCHBEGRIFF THEN
        nimm_letzte_suchbegriffe
      ELSE BEGIN
        FOR cty:=feld TO inh5 DO
          IF erster_begriff[cty]=NIL THEN BEGIN
            New(erster_begriff[cty]);
            erster_begriff[cty]^.begriff:=wildcard;
            erster_begriff[cty]^.naechste:=NIL;
          END;
      END;
      (* Lsche Anweisungen, die mehrfach in *)
      (* der Befehlsliste vorkommen          *)
      ctrlmenge:=[];
      IF REFLEXIV AND (erster_befehl=NIL) THEN
        nimm_letzte_befehle;
      befehl:=erster_befehl;
      WHILE befehl<>NIL DO BEGIN
        IF befehl^.anw IN ctrlmenge THEN BEGIN
          letzter_befehl^.naechste:=befehl^.naechste;
          Dispose(befehl);
        END
        ELSE BEGIN
          ctrlmenge:=ctrlmenge+[befehl^.anw];
          letzter_befehl:=befehl;
          (* Lautet eine Anweisung 'sortieren', *)
          (* so fuehre sie sofort aus           *)
          IF befehl^.anw=sortieren THEN bubble_sort;
        END;
        befehl:=letzter_befehl^.naechste;
      END;
      WriteLn;WriteLn;
      (* Das ATN ist fr eine Anfrage      *)
      (* durchlaufen, nun beantworte diese *)
      IF richtig_verstanden THEN BEGIN
        drucke_antwort;
        merke_letzte_antwort;
        ReadLn;
      END
      ELSE BEGIN
        (* Lsche die Liste der Suchbegriffe,  *)
        (* nachdem die Frage beantwortet wurde *)
        FOR cty:=feld TO inh5 DO BEGIN
          suchbegriff[cty]:=erster_begriff[cty];
          WHILE suchbegriff[cty]<>NIL DO BEGIN
            letzter_begriff[cty]:=suchbegriff[cty];
            suchbegriff[cty]:=suchbegriff[cty]^.naechste;
            Dispose(letzter_begriff[cty]);
          END;
        END;
        befehl:=erster_befehl;
        (* Lsche die Befehlsliste *)
        WHILE befehl<>NIL DO BEGIN
          letzter_befehl:=befehl;
          befehl:=befehl^.naechste;
          Dispose(letzter_befehl);
        END;
      END;
    UNTIL category=pop;
    (* Die Eingabe ist abgearbeitet *)
  END;
  resetfenster;
END;
